#property copyright "Copyright  2006,  Ion Coliujco"
#include <Portfolio.mqh>
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Green
#property indicator_color2 DarkBlue
#property indicator_color3 Red
#property indicator_color4 Black
#property indicator_color5 Maroon
#property indicator_color6 DarkSlateGray
#property indicator_color7 Purple
#property indicator_color8 Teal
//---- buffers
double USD[];
double EUR[];
double GBP[];
double CHF[];
double JPY[];
double AUD[];
double CAD[];
double NZD[];

extern int MomPeriod = 2;
extern int SmoothPeriod = 5;
extern bool ShowOnlyPair=true;

/// Initialization function //

int init()
{
//---- indicators
   IndicatorBuffers(8);
   
   //IndicatorShortName("USD:Green;EUR:Blue;GBP:Red;CHF:Black;JPY:Maroon;AUD:Gray;CAD:Purple;NZD:Teal");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,USD);
   SetIndexLabel(0,"USD"); 
   SetIndexEmptyValue(0,0);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,EUR);
   SetIndexLabel(1,"EUR"); 
   SetIndexEmptyValue(1,0);
      
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,GBP);
   SetIndexLabel(2, "GBP"); 
   SetIndexEmptyValue(2,0);
      
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,CHF);
   SetIndexLabel(3,"CHF"); 
   SetIndexEmptyValue(3,0);
      
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,JPY);
   SetIndexLabel(4,"JPY"); 
   SetIndexEmptyValue(4,0);
      
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,AUD);
   SetIndexLabel(5,"AUD"); 
   SetIndexEmptyValue(5,0);
      
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,CAD);
   SetIndexLabel(6,"CAD");
   SetIndexEmptyValue(6,0);
      
   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,NZD);
   SetIndexLabel(7,"NZD");
   SetIndexEmptyValue(7,0);   

//----
   return(0);
}
int start()
{
//---- indicator buffers mapping
   int limit;
   int counted_bars = IndicatorCounted();
   
   if(counted_bars < 0) return (-1);
   
   limit=Bars-counted_bars;
   
   double TmpUSD[];
   double TmpEUR[];
   double TmpGBP[];
   double TmpCHF[];
   double TmpJPY[];
   double TmpAUD[];
   double TmpCAD[];
   double TmpNZD[];
   

   ArraySetAsSeries(TmpUSD, true);
   ArraySetAsSeries(TmpEUR, true);
   ArraySetAsSeries(TmpGBP, true);
   ArraySetAsSeries(TmpCHF, true);
   ArraySetAsSeries(TmpJPY, true);
   ArraySetAsSeries(TmpAUD, true);
   ArraySetAsSeries(TmpCAD, true);
   ArraySetAsSeries(TmpNZD, true);
   
   ArrayResize(TmpUSD, Bars);
   ArrayResize(TmpEUR, Bars);
   ArrayResize(TmpGBP, Bars);
   ArrayResize(TmpCHF, Bars);
   ArrayResize(TmpJPY, Bars);
   ArrayResize(TmpAUD, Bars);
   ArrayResize(TmpCAD, Bars);
   ArrayResize(TmpNZD, Bars);
   
   int i;
   double SumUSD=0,SumEUR=0,SumGBP=0,SumCHF=0,SumJPY=0,SumAUD=0,SumCAD=0,SumNZD=0;   
   
/// Clear all buffers

   /*
   for(i=0; i<Bars; i++)
   {
      TmpUSD[i]=0;
      TmpEUR[i]=0;
      TmpGBP[i]=0;
      TmpCHF[i]=0;
      TmpJPY[i]=0;
      TmpAUD[i]=0;
      TmpCAD[i]=0;
      TmpNZD[i]=0;
   }*/
  

/// Momentum Cycle
   for(i=0; i<limit-MomPeriod; i++)
   {
      //Print(i+": "+DoubleToStr(SumUSD, 0)+","+USD(i,MomPeriod));
      
      if (USD(i,MomPeriod)==VALUE_ERROR ||
          EUR(i,MomPeriod)==VALUE_ERROR ||
          GBP(i,MomPeriod)==VALUE_ERROR ||
          CHF(i,MomPeriod)==VALUE_ERROR ||
          JPY(i,MomPeriod)==VALUE_ERROR ||
          AUD(i,MomPeriod)==VALUE_ERROR ||
          CAD(i,MomPeriod)==VALUE_ERROR ||
          NZD(i,MomPeriod)==VALUE_ERROR)
      {
        Print(i+": VALUE_ERROR");         
      } 
            
             
      SumUSD+= -USD(i,MomPeriod);
      SumEUR+= -EUR(i,MomPeriod);
      SumGBP+= -GBP(i,MomPeriod);
      SumCHF+= -CHF(i,MomPeriod);
      SumJPY+= -JPY(i,MomPeriod);      
      SumAUD+= -AUD(i,MomPeriod);
      SumCAD+= -CAD(i,MomPeriod);
      SumNZD+= -NZD(i,MomPeriod);
 
      TmpUSD[i]=SumUSD;
      TmpEUR[i]=SumEUR;
      TmpGBP[i]=SumGBP;
      TmpCHF[i]=SumCHF;
      TmpJPY[i]=SumJPY;
      TmpAUD[i]=SumAUD;
      TmpCAD[i]=SumCAD;
      TmpNZD[i]=SumNZD;
      
   }    
   
   for(i=0; i <limit-SmoothPeriod; i++)
   {
      USD[i]=0;
      EUR[i]=0;
      GBP[i]=0;
      CHF[i]=0;
      JPY[i]=0;
      AUD[i]=0;
      CAD[i]=0;
      NZD[i]=0;
   
      if (!ShowOnlyPair)
      {
         USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
         EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
         GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
         CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
         JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
         AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
         CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
         NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);
      }   
      else
      {
         string sym = Symbol();
         
         if (sym == "EURUSD")
         {
            USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
            EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "EURGBP")
         {
            EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
            GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "EURCHF")
         {
            EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
            CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "EURJPY")
         {
            EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
            JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "EURAUD")
         {
            EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
            AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "EURCAD")
         {
            EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
            CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "EURNZD")
         {
            EUR[i]=iMAOnArray(TmpEUR, 0, SmoothPeriod, 0, MODE_SMA, i);
            NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);         
         }
         else
         if (sym == "GBPUSD")
         {
            USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
            GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "GBPCHF")
         {
            GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
            CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "GBPJPY")
         {
            GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
            JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "USDCHF")
         {
            USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
            CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "USDJPY")
         {
            USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
            JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "CHFJPY")
         {
            CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
            JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "AUDUSD")
         {
            USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
            AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "GBPAUD")
         {
            GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
            AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "AUDCAD")
         {
            AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
            CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "AUDCHF")
         {
            CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
            AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "AUDJPY")
         {
            JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
            AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "USDCAD")
         {
            USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
            CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "GBPCAD")
         {
            GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
            CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "CADCHF")
         {
            CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
            CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "CADJPY")
         {
            JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
            CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
         }
         else
         if (sym == "NZDUSD")
         {
            USD[i]=iMAOnArray(TmpUSD, 0, SmoothPeriod, 0, MODE_SMA, i);
            NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);         
         }
         else
         if (sym == "GBPNZD")
         {
            GBP[i]=iMAOnArray(TmpGBP, 0, SmoothPeriod, 0, MODE_SMA, i);
            NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);         
         }
         else
         if (sym == "NZDCHF")
         {
            CHF[i]=iMAOnArray(TmpCHF, 0, SmoothPeriod, 0, MODE_SMA, i);
            NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);         
         }
         else
         if (sym == "NZDJPY")
         {
            JPY[i]=iMAOnArray(TmpJPY, 0, SmoothPeriod, 0, MODE_SMA, i);
            NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);         
         }
         else
         if (sym == "AUDNZD")
         {
            AUD[i]=iMAOnArray(TmpAUD, 0, SmoothPeriod, 0, MODE_SMA, i);
            NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);         
         }
         else
         if (sym == "NZDCAD")
         {
            CAD[i]=iMAOnArray(TmpCAD, 0, SmoothPeriod, 0, MODE_SMA, i);
            NZD[i]=iMAOnArray(TmpNZD, 0, SmoothPeriod, 0, MODE_SMA, i);         
         }
      }   
   }   
   
   return (0);
  }
///////////////////////////////////////////////////////


